'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var makeDirectRequest = function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(reqInfo) {
        var owner, repo, path, ref, resp;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        owner = reqInfo.owner;
                        repo = reqInfo.repo;
                        path = reqInfo.path;
                        ref = reqInfo.ref;
                        _context.next = 6;
                        return fetch('https://raw.githubusercontent.com/' + owner + '/' + repo + '/' + ref + '/' + path);

                    case 6:
                        resp = _context.sent;
                        _context.next = 9;
                        return resp.text();

                    case 9:
                        return _context.abrupt('return', _context.sent);

                    case 10:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function makeDirectRequest(_x) {
        return _ref.apply(this, arguments);
    };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
    var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(reqInfo) {
        var owner, repo, path, ref, resp, data;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        owner = reqInfo.owner;
                        repo = reqInfo.repo;
                        path = reqInfo.path;
                        ref = reqInfo.ref;
                        resp = void 0;
                        _context2.prev = 5;
                        _context2.next = 8;
                        return fetch('https://api.github.com/repos/' + owner + '/' + repo + '/contents/' + path + '?ref=' + ref);

                    case 8:
                        resp = _context2.sent;
                        _context2.next = 14;
                        break;

                    case 11:
                        _context2.prev = 11;
                        _context2.t0 = _context2['catch'](5);
                        return _context2.abrupt('return', makeDirectRequest(reqInfo));

                    case 14:
                        if (!(resp.status !== 200)) {
                            _context2.next = 16;
                            break;
                        }

                        return _context2.abrupt('return', makeDirectRequest(reqInfo));

                    case 16:
                        _context2.next = 18;
                        return resp.json();

                    case 18:
                        data = _context2.sent;

                        if (data.content) {
                            _context2.next = 21;
                            break;
                        }

                        throw Error('Guthub API returned wrong data');

                    case 21:
                        return _context2.abrupt('return', atob(data.content.replace(/\s/g, '')));

                    case 22:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this, [[5, 11]]);
    }));

    function getGithubFile(_x2) {
        return _ref2.apply(this, arguments);
    }

    return getGithubFile;
}();

/* function getFile(data, path, callback) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', 'https://api.github.com/repos/'+data.owner+'/'+data.repo+'/contents/'+path+'?ref=' + data.ref, true);

    xhr.onload = function() {
        var resp = JSON.parse(xhr.responseText);
        if(resp.content) {
            callback(atob(resp.content.replace(/\s/g, '')));
        } else {
            xhr.onerror();
        }
    }

    // fallback in case if API limmit is exceeded
    xhr.onerror = function() {
        var xhr2 = new XMLHttpRequest();
        xhr2.open('GET', 'https://raw.githubusercontent.com/'+data.owner+'/'+data.repo+'/'+data.ref+'/'+path, true);
        xhr2.onload = function() {
            if(xhr2.status !== 200) {
                callback({ error: xhr2.statusText })
            } else {
                callback(xhr2.responseText);
            }
        }

        xhr2.onerror = function() {
            callback({ error: xhr2.statusText });
        }

        xhr2.send();
    }

    xhr.send();
}*/


;

(function () {
    if (typeof __REACT_HOT_LOADER__ === 'undefined') {
        return;
    }

    __REACT_HOT_LOADER__.register(makeDirectRequest, 'makeDirectRequest', 'src/lib/get-github-file.js');
})();

;